using Edu.Common.Enum;
using Edu.Model.Entity.Web;
using Edu.Model.ViewModel.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.Web
{
    /// <summary>
    /// 招聘管理仓储层
    /// </summary>
    public class RB_Web_RecruitmentRepository : BaseRepository<RB_Web_Recruitment>
    {
        /// <summary>
        /// 获取招聘信息分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Web_Recruitment_ViewModel> GetWebRecruitmentPageRepository(int pageIndex, int pageSize, out long rowsCount, RB_Web_Recruitment_ViewModel query)
        {
            rowsCount = 0;
            var parameters = new DynamicParameters();
            StringBuilder builder = new StringBuilder();
            builder.Append(@"
SELECT A.* 
FROM RB_Web_Recruitment AS A
WHERE 1=1
");
            builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Recruitment_ViewModel.Status), (int)DateStateEnum.Normal);
            if (query == null)
            {
                return new List<RB_Web_Recruitment_ViewModel>();
            }
            else
            {
                if (query.Group_Id > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Recruitment_ViewModel.Group_Id), query.Group_Id);
                }
                if (!string.IsNullOrEmpty(query.PositionName))
                {
                    builder.AppendFormat(" AND A.{0} LIKE @PositionName ", nameof(RB_Web_Recruitment_ViewModel.PositionName));
                    parameters.Add("PositionName", "%" + query.PositionName.Trim() + "%");
                }
                if (query.TypeId > 0)
                {
                    builder.AppendFormat(@" AND A.{0}={1} ", nameof(RB_Web_Recruitment_ViewModel.TypeId), query.TypeId);
                }
            }
            builder.AppendFormat(" ORDER BY A.{0} DESC ", nameof(RB_Web_Recruitment_ViewModel.Id));
            return GetPage<RB_Web_Recruitment_ViewModel>(pageIndex, pageSize, out rowsCount, builder.ToString(), parameters).ToList();
        }

    }
}
